#ifndef FZ_TCP_ADDRESS_INFO_HPP
#define FZ_TCP_ADDRESS_INFO_HPP

#include <string>
#include <tuple>

#include "../serialization/helpers.hpp"
#include "../serialization/types/optional.hpp"

namespace fz::tcp {

struct address_info
{
	std::string address{};
	unsigned int port{};

	enum tls_mode_t: uint8_t {
		allow_tls,
		implicit_tls,
		require_tls,
		//Hier 2 neue von ela
		explicit_tls_local_ip,
		non_tls,
		non_tls_local_ip
	} tls_mode = allow_tls;

	template <typename Archive>
	void serialize(Archive &ar)
	{
		ar(FZ_NVP(address), FZ_NVP(port), FZ_NVP_O(tls_mode));
	}

	bool operator <(const address_info &rhs) const
	{
		return std::tie(address, port) < std::tie(rhs.address, rhs.port);
	}
};

}

#endif // FZ_TCP_ADDRESS_INFO_HPP
